#ifndef __LOG_H__
# define __LOG_H__

#include <stdarg.h>
#include "settings.h"

/* Initialize the log by opening the USB connection. */
void log_init(bool wait);

/* Log a string through USB, if the connection is open. true if successful. */
bool log_write(char const *str);

/* Like log_write(), but with variadic arguments. */
bool log_printf(char const *fmt, ...);
bool log_vprintf(char const *fmt, va_list args);

#endif /* __LOG_H__ */
